<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

include "fefunctions.php";
$_SESSION["testPage"] = "";
$_SESSION["statusxml"] = "";
$_SESSION["lastTest"] = 99;
$_SESSION["lastPrompt"] = "";
$_SESSION["statusDrawn"] = "false";
unset($_SESSION["completedTests"]);
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <link rel='stylesheet' type='text/css' href='stylesheets/menu.css'>
  <style> body { background: 006699; } </style>
<SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'></script>
</head>

<?php

  $manualOverride = $_REQUEST["man"];

  $idXml = new DomDocument($_SESSION["idResult"]);
  $root = $idXml->document_element();
  if (!$root->has_child_nodes())
  {
    $resultCommand = sprintf("<getProcessResult processID='%s' />", $_REQUEST["pid"]);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $resultCommand, $_SESSION["idResult"], $idErrors);
    printf("<script language='Javascript'>\nwindow.location='hpdiags.php?pid=%s';\n</script>\n", $_REQUEST["pid"]);
  }
  else
  {
    
    $filepath = $_SESSION["diagsDirectory"] . "diagconfig.xml";
    if (!$dom = LoadXmlDocument($filepath))
    {
      echo "NO DIAG CONFIG";
      exit;
    }

	  $rootXpath = xpath_new_context($dom->document_element());
	  $srcs = xpath_eval($rootXpath, "/src");
	  if (count($srcs->nodeset) && !$manualOverride)
	  {// found a reference to a script file
	    $srcfile = $srcs->nodeset[0]->get_attribute("name");
	    $srcpath = $srcs->nodeset[0]->get_attribute("path");

	    if ($srcpath == "")
	      $srcpath = $_SESSION["diagsDirectory"];

      // if they want to create and use a factory.xml file
      if (strstr($srcfile,"factory.xml"))
	    {
        $contents = getDirectoryContents($_SESSION["diagsDirectory"]); // get all the files from the directory
        
        $dir_length = count($contents);
        for($i=0;$i<$dir_length;$i++)
        {
          if (strstr($contents[$i], ".src.xml")) // found the script file
          {
            if (!file_exists($_SESSION["diagsDirectory"] . "factory.xml"))
            {
              // now translate the script file from DxEdit xml schema to Diags xml schema
		          $dxtransErrors = "";
  	          $dxtransStatus = "";
  	          $dxtransStr = sprintf("<systemCall>%sdxtranslate %s%s</systemCall>", $_SESSION["diagsDirectory"], $_SESSION["diagsDirectory"], $contents[$i]);
  	          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $dxtransStr, $dxtransStatus, $dxtransErrors);
            }
            // open the factory.xml file
            if ($xmldoc = @LoadXmlDocument($srcpath . $srcfile))
            {
              $factoryRoot = $xmldoc->document_element();
              $factoryXML = @xpath_new_context($factoryRoot);
              $station = $factoryRoot->get_attribute("station");
              // find out what script needs to be run first
              $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
              if (count($srcs->nodeset))
              {
                $status = $srcs->nodeset[0]->get_attribute("status");
                if (strstr($status, "assed")) // if Passed or passed
                {
                  $station++;
                  $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
                  if (count($srcs->nodeset))
                    $scriptFile = $srcs->nodeset[0]->get_attribute("name"); // get the script's filename
                  $factoryRoot->set_attribute("station", $station);
                  $result = SaveFile("factory.xml", "harddrive", $xmldoc->dump_mem());
                }
                else
                  $scriptFile = $srcs->nodeset[0]->get_attribute("name"); // get the script's filename
                $scriptFile = $_SESSION["diagsDirectory"] . $scriptFile;
              }
            }
            break;
          }
        }
        
	    }
      else
        $scriptFile = $srcpath . $srcfile;

	    if ($scriptXmldoc = @LoadXmlDocument($scriptFile))
		  {
        $scriptRoot = @xpath_new_context($scriptXmldoc->document_element());
        $runTests = @xpath_eval($scriptRoot, "/diagRun/runTest");
        if (count($runTests->nodeset))
        {
          // Submit the diagRun command - script file
		      $runErrors = "";
  	      $runStatus = "";
          if (GetLanguage() == "ja")
            $diagRunStr = sprintf("%s", $scriptXmldoc->dump_mem(true, "UTF-8"));
          else
            $diagRunStr = sprintf("%s", $scriptXmldoc->dump_mem());
  	      $_SESSION["diagRun"] = $diagRunStr;
  	      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
  	      $xmldoc = new DomDocument($runStatus);+
  
  	      $_SESSION["statusxml"] = "";
  
		      $rootElement = $xmldoc->document_element();
  	      $_SESSION["testpid"] = $rootElement->get_attribute("processID");
          $_SESSION["testPage"] = "customtest.php";

  	      // GO TO STATUS PAGE NOW...
          printf("<frameset  rows='0,0,130,*' framespacing=0 frameborder=0 border=0 ");

          // the unload is only here to call the exit page when manually closing the browser
          if (IsOnline()) // offline you can not manually close the browser
            printf("onunload=\"window.location='exit.php';\"");
          printf(">\n");
          printf("  <frame name='globalFrame' src='globals.php?testMode=interactive' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
          printf("  <frame name='invisibleFrame' src='' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
          printf("  <frame name='headerFrame' src='header.php' marginWidth=0 marginHeight=0 scrolling='no'>\n");
          printf("  <frameset  cols='180,*' framespacing=0 frameborder=0 border=0 name='bottomFrame' >\n");
          printf("	<frame name='menuFrame' src='statusmenu.php' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
          printf("	<frame name='dataFrame' src='statusframe.php' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
          printf("  </frameset>\n");
          printf("</frameset>\n");
          
        }                              
        else
        { 
  	      printf("<script language=\"JavaScript\">\n");
          printf("alert('%s');\n", TR("MSG_NO_TESTS_DEFINED_IN_SCRIPT_FILE"));
  	      printf("</script>\n");          
        }
		  }
      else
      { 
  	    printf("<script language=\"JavaScript\">\n");
        printf("alert('Could not open script file - Please verify diagconfig.xml');\n");
  	    printf("</script>\n");          
      }
		  	    
	  }
    else
    {
      printf("<frameset  rows='0,0,130,*' framespacing=0 frameborder=0 border=0 ");
      if (IsOnline())
       printf("onunload=\"window.location='exit.php';\"");
      printf(">\n");
      printf("  <frame name='globalFrame' src='globals.php' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
      printf("  <frame name='invisibleFrame' src='' noresize marginwidth=0 marginheight=0 scrolling=auto>\n");
      printf("  <frame name='headerFrame' src='header.php' marginWidth=0 marginHeight=0 scrolling='no'>\n");
      printf("  <frameset  cols='180,*' framespacing=0 frameborder=0 border=0 name='bottomFrame' >\n");
      printf("	<frame name='menuFrame' src='surveymenu.php' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
      printf("	<frame name='dataFrame' src='survey.php?category=All' marginWidth=10 marginHeight=10 scrolling='auto'>\n");
      printf("  </frameset>\n");
      printf("</frameset>\n");
    }
  }
?>
